<template>
    <v-layout row wrap competition>
        <v-flex xs12 text-xs-center>
            <h1>Wettbewerbsfragen</h1>
            <h3 v-if="isInitialized">{{ question.question }}</h3>
            <h3 v-else>LOADING...</h3>
        </v-flex>

        <v-flex xs12>
            <!-- https://vuejs.org/v2/style-guide/#Avoid-v-if-with-v-for-essential -->
            <v-form lazy-validation v-if="isInitialized">
                <v-radio-group v-model="answer" ref="form" >
                    <v-radio
                            v-for="(answer, key) in question.answers"
                            :key="key"
                            :label="answer.toString()"
                            :value="answer.toString()"
                    ></v-radio>
                </v-radio-group>
                <p class="purple--text darken-1 font-weight-bold" v-if="!valid">Please choose an answer!</p>

                <div class="text-xs-center">
                    <v-btn class="red accent-4 white--text" @click="cancel()">Abbrechen</v-btn>
                    <v-btn color="green white--text" @click="proceed()">{{ question.nextQuestionId !== null ? 'Weiter' : 'Fertig' }}</v-btn>
                </div>

                <div v-if="isProcessing" class="text-xs-center mt-4">
                    <img src="../assets/images/loader.gif" alt="preloader" width="32">
                </div>
            </v-form>
        </v-flex>
    </v-layout>
</template>

<script>
    import { mapGetters } from "vuex";
    import {DEFAULT_QUESTION_STATE} from '../config.types';

    export default {
        created() {
            let question = this.$store.getters.question;

            if (undefined === question || question.id === 0) {
                //this.finish();
            }
        },
        props: {
            hasValidationErrors: false
        },
        data() {
            return {
                valid: true,
                answer: null
            };
        },
        computed: {
            ...mapGetters(['question', 'isInitialized', 'isProcessing'])
        },
        methods: {
            cancel() {
                this.$router.push({name: 'home'});
            },
            proceed() {
                this.valid = true;
                if (this.answer === null) {
                    this.valid = false;

                    return false;
                }

                this.$store.dispatch('commitAnswer', this.answer);
                this.$store.commit('setQuestion', DEFAULT_QUESTION_STATE);

                if (this.question === undefined || null === this.question.nextQuestionId) {
                    this.finish();
                }

                // reset the form
                this.answer = null;

                this.$router.go(); // not nice: Hack to proceed to next question because this is currently not working :/
            },
            finish() {
                this.$router.push({name: 'result'})
            }
        }
    }
</script>
